/* approx.h
 * Approximation algorithms for RFLCS (header file)
 */

#include <stdlib.h>

#include "glpk.h"

#include "util.h"
#include "ip.h"

#define PROB_TIMES 20   /* Number of times a probabilistic algorithm is run */

int lcs_cormen (int *x, int *y, int *z, int m, int n);
int rflcs_approx1 (int *x, int *y, int *z, int m, int n, int asize);
int rflcs_approx2 (int *x, int *y, int *z, int m, int n, int type, int asize);
int rflcs_approx2_derand (int *x, int *y, int *z, int m, int n, int asize);
void choice_1 (int *xcount, int *ycount, int *xchoice, int *ychoice, 
	       int asize);
void choice_2 (int *xcount, int *ycount, int *xchoice, int *ychoice, 
	       int asize);
unsigned int choice_2_derand (int *xcount, int *ycount, int *xchoice, 
			      int *ychoice, int asize, unsigned int k, 
			      unsigned int lcm);
void prepare_3 (int *x, int *y, int m, int n, int *xcount, int *ycount,
                int asize, double **prob);
void construct_prob_lp (glp_prob *lp, int *x, int *y, int m, int n, 
			int *xcount, int *ycount, int asize, crossdata_t *cd, 
			double **prob);
void choice_3 (int *xcount, int *ycount, int *xchoice, int *ychoice, 
               int asize, double **prob);
void count_seq (int *xcount, int *ycount, int *x, int *y, int m, int n, 
		int asize);
int choose_seq (int *x, int *xaux, int *choice, int m);
