/* crossdata.c
 * Crossdata structure functions
 */

#include "crossdata.h"

/* Allocates memory for a crossdata structure.
 */
crossdata_t *malloc_crossdata (int m, int n, int asize)
{
  int i;
  crossdata_t *cd;

  cd = (crossdata_t *) malloc_chk(sizeof (crossdata_t));
  cd->crossx = (int *) malloc_chk(m * n * sizeof (int));
  cd->crossy = (int *) malloc_chk(m * n * sizeof (int));
  cd->revcross = (int **) malloc_chk(m * sizeof (int *));
  for (i = 0; i < m; i++)
    cd->revcross[i] = (int *) malloc_chk(n * sizeof (int));
  cd->scross = (int *) malloc_chk(asize * sizeof (int));
  cd->csize = 0;

  return cd;
}

/* Frees the memory allocated for a crossdata structure.
 */
void free_crossdata (crossdata_t *cd, int m)
{
  int i;

  for (i = 0; i < m; i++)
    free(cd->revcross[i]);
  free(cd->revcross);
  free(cd->crossx);
  free(cd->crossy);
  free(cd->scross);
  free(cd);
}
