/* crossdata.h
 * Crossdata structure functions (header file)
 */

#include <stdlib.h>

#include "util.h"

/* The variables in the IP are represented by indices. This data structure
 * associates these indices with the alignment they represent.
 */
#ifndef CROSSDATA_DEFINED
struct crossdata {
  int *crossx;    /* crossx[k] is the index of the variable k on x */
  int *crossy;    /* crossy[k] is the index of the variable k on y */
  int csize;      /* csize is the number of total variables in the IP */
  int **revcross; /* revcross[i][j] is the index of the variable representing
		   * alignment (i, j). It is the reverse of crossx/crossy. */
  int *scross;    /* The variable indices are ordered by symbol. scross[s] is 
		   * the index of the first variable with symbol s. */
};

typedef struct crossdata crossdata_t;
#endif
#define CROSSDATA_DEFINED 1

crossdata_t *malloc_crossdata (int m, int n, int asize);
void free_crossdata (crossdata_t *cd, int m);
