/* graph.h
 * Graph construction and manipulation (header file)
 */

#include "util.h"

#ifndef GRAPH_DEFINED
struct graph {
  int **vmap;
  int **revmap;
  int nv;
  int **adj;
};

typedef struct graph graph_t;
#endif
#define GRAPH_DEFINED 1

void construct_vertex_map (int *x, int *y, int m, int n, int asize,
			   graph_t *graph);
void construct_graph (int m, int n, graph_t *graph);
void find_noncross_vertices (int m, int n, int i, int j, int reverse, 
			     int vij, graph_t *graph);
void find_cross_vertices (int m, int n, int i, int j, int reverse, 
			  int vij, graph_t *graph);
void find_cross_vertices_incl (int m, int n, int i, int j, int reverse, 
			       int vij, graph_t *graph);
void top_left_edges (int m, int n, int vij, graph_t *graph);
void top_right_edges (int m, int n, int vij, graph_t *graph);
void construct_graph_complete (int *x, int *y, int m, int n, graph_t *graph);
void free_graph (int m, int n, graph_t *graph);
