/* ip.h
 * Integer programming functions (header file)
 */

#include <stdio.h>
#include <stdlib.h>

#include "glpk.h"

#include "util.h"
#include "graph.h"
#include "crossdata.h"
#include "preprocess.h"

#define MODPATH "rflcs.mod"
#define DATPATH "rflcs.dat"

#define EPSILON 1e-7

int rflcs_ip (int *xo, int *yo, int *z, int mo, int no, int asize, 
	      graph_t *graph);
void construct_data_ip (int *x, int *y, int m, int n, int asize, 
			crossdata_t *cd);
void construct_model_ip ();
void construct_model_max_ip (graph_t *graph);
void construct_model_reponly_ip ();
void search_graph (FILE *modfile, graph_t *graph, int *stack, int *top, 
                   int v, int *k);
int convert_lp_to_sequence (glp_prob *lp, int *x, int *y, int *z,
			    crossdata_t *cd, int mip);
void convert_sequence_to_vars (int *x, int *y, int *s, int k, double *vars, 
			       crossdata_t *cd);
