/* rflcs.c
 * Main file for RFLCS (header file)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <time.h>
#include <unistd.h>
#include <sys/times.h>

#include "approx.h"
#include "util.h"
#include "seqgen.h"
#include "metapost.h"
#include "ip.h"
#include "graph.h"
#include "solver.h"

#define MAX_FNAME 256  /* Maximum length of a file name */

/* If defined, redirects glpk output to /dev/null when used silent param.
 * Breaks silent if commented, but comment the following line if it causes 
 * you problems and you don't need silent. */
#define MEAN_SILENCE 1

/* A hack for time limit. Can be refactored. -1 means no limit, and the 
 * time is in seconds. */
#define TIME_LIMIT -1

int run_algorithm (int *x, int *y, int *z, int m, int n, int silent, 
                   int metapost, FILE *mpfile, int *mpn, int color, 
                   int asize, graph_t *graph, int alg);
