/* solver.h
 * An exact solver based on branch and cut (header file)
 */

#include <sys/times.h>
#include <unistd.h>

#include "approx.h"
#include "util.h"
#include "ip.h"
#include "preprocess.h"

struct info {
  int *x;
  int *y;
  int *z;
  int m;
  int n;
  int asize;
  crossdata_t *cd;
  int *xcount;
  int *ycount;
  int init_lower;
};

typedef struct info info_t;

int rflcs_bc (int *xo, int *yo, int *z, int mo, int no, int asize);
int relax_cut_loop (glp_prob *lp, int *x, int *y, int *z, int m, int n, 
                    int asize, crossdata_t *cd, int *xcount, int *ycount,
                    int *heuristic);
int max_cross (int *x, int *y, int *zi, int *zj, int m, int n, 
               double **weight, double *wsum);
int max_cross_2 (int *x, int *y, int *zi, int *zj, int m, int n,
		 crossdata_t *cd, double **weight, double *wsum);
int max_cross_3 (int *x, int *y, int *zi, int *zj, int m, int n,
		 crossdata_t *cd, double **weight, double *wsum,
		 glp_prob *lp);
int prob_approx (glp_prob *lp, int *x, int *y, int *z, int m, int n, 
		 int asize, int *xcount, int *ycount, crossdata_t *cd,
		 int kmax);
void callback_bb (glp_tree *tree, void *info);
info_t *create_info (int *x, int *y, int *z, int m, int n, int asize,
		     crossdata_t *cd, int *xcount, int *ycount, int lower);
void print_status (int iter, double wsum, int lower, double obj_val);

extern int generate_cuts (LPX *prob, int use_cuts);
